function guiFillGrid(tableId)
{
	// DOM insertion
	for(var rr = 0; rr < 6; rr++) {
		var oRow;
		oRow = tableId.insertRow();

		for(var ff = -1; ff < 14; ff++) {
			var oCell;
			oCell = oRow.insertCell();
			if(ff == -1) {
				oCell.innerHTML = "<span id=\"r"+rr+"fX\" class=\"fretOff\">O</span>";
			} else if(ff == 12) {
				oCell.innerHTML = "<span id=\"r"+rr+"fC\">&nbsp;ch</span>";
			} else if(ff == 13) {
				oCell.innerHTML = "<span id=\"r"+rr+"fV\">&nbsp;v</span>";
			} else {
				oCell.innerHTML = "<span id=\"r"+rr+"f"+ff+"\" class=\"fretOff\">"+ff+"</span>";
			}
		}
	}
}


function guiUpdate()
{

	// DOM insertion
	for(var rr = 0; rr < 6; rr++) {
		for(var ff = 0; ff < 12; ff++) {
			var note = ff + patch.row[rr].baseNote;

			if(patch.row[rr].channel > 0) {

				document.getElementById("r" + rr + "f" + ff).innerText =
					String(noteNames[note%12]) + String(Math.floor(note/12)+baseOctave);
			} else {

				document.getElementById("r" + rr + "f" + ff).innerText = "X";

			}

		}

		if(patch.playStyle == PLAY_GUITAR) {
			guiVelocity(rr, " ");
		} else {
			guiVelocity(rr, -1);
		}

		guiChannel(rr, patch.row[rr].channel);

	}

	patchName.innerText = "[" + configMode + "] " + patch.name;
	patchDesc.innerText = patch.description;

	switch(patch.playStyle) {
	case PLAY_KEYBOARD: patchMode.innerText = "Keyboard"; break;
	case PLAY_GUITAR: patchMode.innerText = "Guitar"; break;
	case PLAY_FRETBOARD: patchMode.innerText = "Fretboard"; break;
	case PLAY_CONTINUOUS: patchMode.innerText = "Continuous"; break;
	}
}


function guiFret(mode, row, fret)
{
	if(fret < -1) {
		return;
	}

	if(fret == -1) {
		// Open string special logic
		fret = "X";
		//if(mode == 2) mode = 0;
	}

	var newclass = "fretOff";

	switch(mode) {
	case 0: newclass = "fretOff"; break;
	case 1: newclass = "fretOn"; break;
	case 2: newclass = "fretDim"; break;
	case 3: newclass = "fretHold"; break;
	}

	document.getElementById("r" + row + "f" + fret).className = newclass;
}


function guiVelocity(row, vel)
{
	if(vel == -1) {
		document.getElementById("r" + row + "fV").innerText = "";
	} else {
		document.getElementById("r" + row + "fV").innerText = " vel " + vel;
	}
}


function guiChannel(row, ch)
{
	if(ch < 1) {
		document.getElementById("r" + row + "fC").innerText = " off";
	} else {
		document.getElementById("r" + row + "fC").innerText = " ch " + ch;
	}
}

